"use strict";/**
 * @preserve Copyright 2022 - Chris West - MIT Licensed
 * 
 * When this code is first executed it will call `prismizeAll()`.  The order of
 * precedence for the options is (1) the `opt_options` passed in to
 * `prismize()`, (2) the corresponding data attributes on any `code` element
 * passed to `prismize()`, and (3) the corresponding camel cased options as
 * defined in the URL of the script tag that defines and executes this code.
 */var _ref=function(a){var b=Math.min;function c(c,d,e){var l,m=0,n=/^(false|no|off|0|true|yes|on|1|)$/i,o=/^(false|no|off|0)$/i,p=Object.assign({},Object(e));null!==(l=p.actions)&&void 0!==l?l:p.actions=[],"string"!=typeof c&&function(){var e,f,g,h,k;["copyable","downloadName","downloadable","endWithInfoBar","infoHTML","infoText","matchBraces","maxHeight","numberLines","placement","previewColors","removeMargins","resizeRate","showLanguage","tabSize","templatePath","theme"].forEach(function(a){var b="data-"+a.replace(/[A-Z]+/g,"-$&").toLowerCase();p.hasOwnProperty(a)||(c.hasAttribute(b)?p[a]=c.getAttribute(b):j.hasOwnProperty(a)&&(p[a]=j[a]))}),null!==(e=d)&&void 0!==e?e:d=c.getAttribute("data-prismize")||c.getAttribute("data-language"),p.placeholder=c,null!==(f=p.id)&&void 0!==f?f:p.id=c.id,p.resizeRate=+p.resizeRate,["endWithInfoBar","matchBraces","previewColors","removeMargins"].forEach(function(a){var b;p[a]=!o.test(null!==(b=p[a])&&void 0!==b?b:"0")}),p.theme||(p.theme="default"),null!==(g=p.numberLines)&&void 0!==g?g:p.numberLines="no",p.numberLines=n.test(p.numberLines)&&"0"!=p.numberLines?!o.test(p.numberLines):+p.numberLines,["copyable","downloadable","showLanguage"].forEach(function(a){var b;null!==(b=p[a])&&void 0!==b?b:p[a]="0",n.test(p[a])&&(p[a]=!o.test(p[a]))}),c.className=null===(h=c.className)||void 0===h?void 0:h.replace(/(?:^|\s)prismize(?:\s|$)/g," prismized "),null!==(k=p.className)&&void 0!==k?k:p.className=c.className,m=+p.maxHeight?b(c.clientHeight,+p.maxHeight):c.clientHeight;for(var l=[],q=function c(a,b){var d=b[a],e=d.name,f=d.value;e.replace(/^data-action-(.+)$/,function(a,b){l.push({id:b,name:b.replace(/-([^\-])/g,function(a,b){return b.toUpperCase()}),label:f})})},r=c,s=r.attributes,t=s.length;t--;)q(t,s);p.actions=l.sort(function(c,a){return c.id<a.id?-1:1}).concat(p.actions),c=Object.assign(a.createElement("pre"),{innerHTML:c.innerHTML.replace(/<br.*?>/g,"\n")}).textContent}();var q=a.createElement("IFRAME");Object.assign(q.style,{height:m+"px",width:p.width||"100%",border:"none",display:"block"}),p.className&&(q.className=p.className),p.id&&(q.id=p.id);var r=i(p),s=r.cssPaths,t=r.jsPaths,u=("_"+Math.random()+Math.random()).replace(/\./g,"_"),v=["language-".concat(d)];p.numberLines&&v.push("line-numbers"),p.matchBraces&&v.push("match-braces");var w=[["class",v.join(" ")],["data-start","number"==typeof p.numberLines?p.numberLines:1]].reduce(function(a,b){return a+(b[1]==void 0?"":" ".concat(b[0],"=\"").concat(g(b[1]),"\""))},""),x=Object.assign(a.createElement("div"),{innerText:f(c,{tabSize:+p.tabSize||void 0})}).innerHTML.replace(/<br.*?>/g,"\n"),y=s.map(function(a){return"<link rel=\"stylesheet\" href=\"".concat(a,"\" crossorigin=\"anonymous\" />")}),z="body{margin:0;overflow:hidden;}#wrapper{overflow:hidden;}"+"#infoBar{font-size:0.85em;color:#333;background-color:#EEE;border-radius:0.3em;overflow:hidden;box-shadow:0 0 1px 1px #000,0 ".concat(p.endWithInfoBar?"-":"","0.4em 0.4em -0.2em;margin:").concat(p.endWithInfoBar?"0.4em 2px 2px":"2px 2px 0.4em",";background-image:linear-gradient(to bottom,rgba(255,255,255,0.2),rgba(255,255,255,0.05) 50%,rgba(0,0,0,0.05) 50%,rgba(0,0,0,0.2));font-family:Tahoma;text-shadow:0.1em 0.1em 0.1em #fff;display:flex;user-select:none;}")+"#infoBar .content{flex:1;text-overflow:ellipsis;white-space:nowrap;overflow:hidden;}#infoBar>a,#infoBar .content{padding:0.4em 0.8em;}#infoBar>a{text-decoration:none;box-shadow:0 0 1px #000;background-color:rgba(0,0,0,0.5);color:#FFF;text-shadow:0 0 1px #000;cursor:pointer;transition:0.25s ease all;}#infoBar>a:hover{background-color:rgba(0,0,0,0.7);color:#FFF;}#infoBar .success{background-color:rgba(0,127,0,0.7)!important;}#infoBar .failure{background-color:rgba(127,0,0,0.7)!important;}#infoBar .tag{filter:grayscale(1);display:inline-block;background-color:hsla(0,100%,50%,0.7);color:#FFF;text-shadow:0 0 0.1em #000;padding:0.2em 0.5em;box-shadow:0 0 1px #000,inset 0 0 0 1px #fff;margin:0 0.5em;font-size:0.85em;font-weight:bold;letter-spacing:0.05em;text-transform:uppercase;}#infoBar :first-child{margin-left:0;}"+(p.removeMargins?"pre[class*=language-]{margin:0;}":"")+(p.maxHeight==void 0?"":"pre[class*=language-]>code{overflow-y:auto;}");y.splice(1,0,"<style>".concat(z,"</style>"));var A="";if(p.downloadable||p.copyable||p.infoText||p.infoHTML||p.showLanguage){var B,C,D=p.actions.map(function(a){return Object.assign(a,{show:!0})}).concat([{name:"copy",label:"string"==typeof p.copyable?p.copyable:"Copy",show:p.copyable},{name:"download",label:"string"==typeof p.downloadable?p.downloadable:"Download",show:p.downloadable}]).reduce(function(a,b){var c=b.name,d=b.label,e=b.show;return e&&(a+="<a href=\"javascript:;\" data-action=\"".concat(g(c),"\">").concat(g(d),"</a>")),a},""),E=null!==(B=p.infoHTML)&&void 0!==B?B:g(null!==(C=p.infoText)&&void 0!==C?C:""),F="boolean"==typeof p.showLanguage?d:p.showLanguage,G=p.showLanguage?"<div class=\"language tag\" style=\"filter: grayscale(0) hue-rotate(".concat(36e4*h(F),"deg);\">").concat(g(F),"</div>"):"";A="<div id=\"infoBar\">"+"<div class=\"content\">".concat(G).concat(E,"</div>")+D+"</div>"}var H="<base target=\"_parent\" />"+y.join("")+"<div id=\"wrapper\">"+(p.endWithInfoBar?"":A)+"<pre".concat(w,"><code>").concat(x,"</code></pre>")+(p.endWithInfoBar?A:"")+"</div><script>("+function(){var a,b,c=void 0,d=window,f=d.document,g=f.body,h=":OPTIONS:";f.querySelectorAll("[data-action]").forEach(function(a){a.addEventListener("click",function(a){a.preventDefault(),window.parent.postMessage({code:g.querySelector("pre").textContent,action:a.target.getAttribute("data-action"),id:":IDENTIFIER:"},"*")})}),window.addEventListener("message",function(a){var b=Object(a.data);"string"==typeof b.action&&"boolean"==typeof b.success&&f.querySelectorAll("[data-action]").forEach(function(a){a.getAttribute("data-action")===b.action&&(a.className+=b.success?" success":" failure",setTimeout(function(){a.className=a.className.replace(/(^|\s+)(success|failure)(\s+|$)/," ").trim()},1e3))})}),setInterval(function(){var c=g.querySelector("#wrapper"),d=g.querySelector("pre"),e=d.querySelector("code"),f=c.offsetHeight-d.offsetHeight;if(h.maxHeight!=void 0){var i=h.maxHeight-f;b!==i&&(b=i,e.style.maxHeight=i+"px")}c.offsetHeight!==a&&(a=c.offsetHeight,window.parent.postMessage({height:a,id:":IDENTIFIER:"},"*"))},h.resizeRate||100)}.toString().replace(/":IDENTIFIER:"/g,JSON.stringify(u)).replace(/":OPTIONS:"/g,JSON.stringify(p))+")()</script>"+t.map(function(a){return"<script src=\"".concat(a,"\" crossorigin=\"anonymous\"></script>")}).join("");q.src="data:text/html;charset=UTF-8,"+encodeURIComponent(H),window.addEventListener("message",function(c){if(c.source===q.contentWindow){var f=Object(c.data);if(f.id===u)if("number"==typeof f.height){var g=f.height;null!=p.maxHeight&&(g=b(g,+p.maxHeight)),q.style.height="".concat(g,"px"),p.onResize&&p.onResize(q,e)}else if(f.action){var h=function b(a){c.source.postMessage({action:f.action,success:!!a},"*")};try{if("download"===f.action)Object.assign(a.createElement("a"),{href:"data:text/plain;charset=utf-8,"+encodeURIComponent(f.code),download:p.downloadName||"".concat(d," (").concat(new Date().toJSON(),").txt")}).click();else if("copy"===f.action){var i=h;navigator.clipboard.writeText(f.code).then(function(){return i(!0)})["catch"](function(){return i()}),h=void 0}else p.onAction&&p.onAction(f.action,f.code,q,p),k.forEach(function(a){return a(f.action,f.code,q,p)});h&&h(!0)}catch(a){h(),console.error&&console.error(a)}}}});var I=p.placement||(p.placeholder?"replace":"end"),J=p.placeholder||a.body,K="start"===I||"end"===I?J:J.parentNode;K.insertBefore(q,"start"===I?J.firstChild:"after"===I?J.nextSibling:"end"===I?null:J),"replace"===I&&K.removeChild(J),p.onLoad&&p.onLoad(q,e)}function d(){function b(){a.querySelectorAll("[data-prismize],.prismize").forEach(function(a){return c(a)})}/^(complete|interactive)$/.test(a.readyState)?b():a.addEventListener("DOMContentLoaded",b)}function e(a,b){var c="\\[\\[("+Object.keys(b).reduce(function(a,b){return a.concat(["".concat(b)])},[]).join("|")+")\\]\\]";return a.replace(new RegExp(c,"g"),function(a,c){return b[c]})}function f(a,c){var d,e;c=Object(c);var f=null!==(d=c.tabSize)&&void 0!==d?d:4,g=null===(e=c.trim)||void 0===e||e;if(a=a.replace(/\t/g," ".repeat(f)),!/(^|[\r\n])\S/.test(a)){for(var h,i=/(^|[\r\n])((?:(?!\r|\n)\s)+)(?=(\S)?)/g,j=1/0;h=i.exec(a);)h[3]&&(j=b(j,h[2].length));a=a.replace(i,function(a,b,c){return b+c.slice(j)})}return g?a.replace(/^(\s*[\r\n]+)+|\s+$/g,""):a}function g(b){return Object.assign(a.createElement("div"),{innerText:b}).innerHTML}function h(a){var b=Math.pow;return a=a.toUpperCase().replace(/([A-Z])|[^]/g,function(a,b){return b?(a.charCodeAt(0)-65).toString(26):""}),parseInt(a,26)/(b(26,a.length)-1)}function i(a){function b(b){return e(a.templatePath,{version:"1.X.X",path:b})}var c=a.theme;/^[\w\-]*$/.test(c)&&(c="default"===c?"":"-"+a.theme,c=b("themes/prism".concat(c,".min.css")));var d,f=[c],g=[b("prism.min.js"),b("plugins/autoloader/prism-autoloader.min.js")];return a.numberLines&&(d="plugins/line-numbers/prism-line-numbers.min.",f.push(b(d+"css")),g.push(b(d+"js"))),a.matchBraces&&(d="plugins/match-braces/prism-match-braces.min.",f.push(b(d+"css")),g.push(b(d+"js"))),a.previewColors&&(d="plugins/inline-color/prism-inline-color.min.",f.push(b(d+"css")),g.push(b(d+"js"),b("components/prism-css-extras.min.js"))),{cssPaths:f,jsPaths:g}}var j=Array.from((a.currentScript.src||"").replace(/\+/g," ").matchAll(/[?&]([^=&#]+)(?:=([^&#]*))?/g)).reduce(function(a,b){var c=b[1],d=b[2];return a[decodeURIComponent(c)]=d?decodeURIComponent(d):"",a},{});j.templatePath="https://cdn.jsdelivr.net/npm/prismjs@[[version]]/[[path]]";var k=[];c.listenToActions=function(a){k.push(a)};try{d()}finally{return{prismize:c,prismizeAll:d}}}(window.document),prismize=_ref.prismize,prismizeAll=_ref.prismizeAll;